#ifndef _BT_SUBTRACKER_H_
#define _BT_SUBTRACKER_H_

#include <set>
#include "bt_tracker.h"

class bt_peer;
 
class bt_subtracker : public bt_tracker {

	vector<bt_peer*> _local_clients;
	vector<bt_peer*>* _external_track_clients;	/* added by Ruchir on Jun 29'05 to support per AS number of external
								connections*/
	bt_tracker *_tracker;

public:
	/**
	 * Default constructor
	 */
	bt_subtracker();
	virtual ~bt_subtracker() { }

	/**
	 * Sets the main tracker for the subtracker.
	 * @param tracker	the pointer to the main tracker
	 */
	void set_tracker(bt_tracker *tracker);

	/**
	 * Overrides bt_tracker's announce method.  Favors local peers
	 * over external peers in returned neighbor list.
	 * @param in_client	the client requesting the neighbors
	 * @return the vector of neighbors
	 */
	virtual vector<bt_peer*>* announce(bt_peer* in_client);

	/**
	 * Handles a peer leaving.  Cleans up state.
	 * @param leaving_peer	the peer that is leaving
	 */
	virtual void peer_leaving(bt_peer* leaving_peer);
};

#endif /* _BT_SUBTRACKER_H_ */
